<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

class PayperfileController extends JControllerLegacy
{
	protected $default_view = 'payperfiles';
	
	function __construct($config = array())
	{
		parent::__construct($config);

		$this->registerTask( 'loadps', 'loadps');
		$this->registerTask( 'loadfm', 'loadfm');
	}
	
	public function display($cachable = false, $urlparams = false)
	{
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';

		$view   = $this->input->get('view', 'payperfiles');
		$layout = $this->input->get('layout', 'default');
		$id     = $this->input->getInt('id');

		if ($view == 'payperfile' && $layout == 'edit' && !$this->checkEditId('com_payperfile.edit.payperfile', $id)) {
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_UNHELD_ID', $id));
			$this->setMessage($this->getError(), 'error');
			$this->setRedirect(JRoute::_('index.php?option=com_payperfile&view=payperfiles', false));
			return false;
		}
		
		parent::display();

		return $this;
	}
	
	function loadps() 
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_installer');
		
		$msg = JText::sprintf('COM_INSTALLER_INSTALL_ERROR', JText::_('COM_INSTALLER_TYPE_TYPE_PLUGIN' ));
		
		if($this->ppfload('ps'))
		$msg = JText::sprintf('COM_INSTALLER_INSTALL_SUCCESS', JText::_('COM_INSTALLER_TYPE_TYPE_PLUGIN' ));
		
		$this->setRedirect('index.php?option=com_payperfile&view=paysystem', $msg);
	}
	
	function loadfm() 
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_installer');
		
		$msg = JText::sprintf('COM_INSTALLER_INSTALL_ERROR', JText::_('COM_INSTALLER_TYPE_TYPE_PLUGIN' ));
		
		if($this->ppfload('fm'))
		$msg = JText::sprintf('COM_INSTALLER_INSTALL_SUCCESS', JText::_('COM_INSTALLER_TYPE_TYPE_PLUGIN' ));
		
		$this->setRedirect('index.php?option=com_payperfile&view=payperfile', $msg);
	}
	
	
	function ppfload($ppf) 
	{
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
		$userfile = JRequest::getVar('file', '', 'files', 'array');

		if (!(bool) ini_get('file_uploads')) {
			JError::raiseWarning('', JText::_('COM_INSTALLER_MSG_INSTALL_WARNINSTALLFILE'));
			return false;
		}
		if (!extension_loaded('zlib')) {
			JError::raiseWarning('', JText::_('COM_INSTALLER_MSG_INSTALL_WARNINSTALLZLIB'));
			return false;
		}
		if (!is_array($userfile) ) {
			JError::raiseWarning('', JText::_('COM_INSTALLER_MSG_INSTALL_NO_FILE_SELECTED'));
			return false;
		}
		if ( $userfile['error'] || $userfile['size'] < 1 ) {
			JError::raiseWarning('', JText::_('COM_INSTALLER_MSG_INSTALL_WARNINSTALLUPLOADERROR'));
			return false;
		}
		
		$config		= JFactory::getConfig();
		$tmp_dest	= $config->get('tmp_path') . '/' . $userfile['name'];
		$tmp_src	= $userfile['tmp_name'];
		
		$uploaded = JFile::upload($tmp_src, $tmp_dest);
		$package = JInstallerHelper::unpack($tmp_dest);
		
		if ($package['type']!='payperfile') {
			JError::raiseWarning('', JText::_('COM_INSTALLER_NO_INSTALL_TYPE_FOUND'));
			return false;
		}
		
		$path = JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.$ppf.DS.JFile::getName($package['dir']);
		 JFolder::copy($package['dir'], $path);
		 
		JInstallerHelper::cleanupInstall($package['packagefile'], $package['extractdir']);
		
		return true;
	}
	
	
}

