<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

class PayperfileHelper
{
	public static function addSubmenu($vName = 'payperfiles')
	{
		JHtmlSidebar::addEntry(
			JText::_('PPF_TITLE'),
			'index.php?option=com_payperfile',
			$vName == 'payperfiles'
		);
		JHtmlSidebar::addEntry(
			JText::_('PPF_CATEGORIES'),
			'index.php?option=com_categories&extension=com_payperfile',
			$vName == 'categories'
		);
		JHtmlSidebar::addEntry(
			JText::_('PPF_PS'),
			'index.php?option=com_payperfile&view=paysystems',
			$vName == 'paysystems'
		);
		JHtmlSidebar::addEntry(
			JText::_('PPF_LBL'),
			'index.php?option=com_payperfile&view=folders',
			$vName == 'folders'
		);
		JHtmlSidebar::addEntry(
			JText::_('PPF_SETTING'),
			'index.php?option=com_config&view=component&component=com_payperfile',
			$vName == 'config'
		);
		JHtmlSidebar::addEntry(
			JText::_('PPF_V7_STAT'),
			'index.php?option=com_payperfile&view=statistics',
			$vName == 'statistics'
		);
		if ($vName=='categories') {
			JToolBarHelper::title(
				JText::sprintf('COM_CATEGORIES_CATEGORIES_TITLE', JText::_('com_payperfile')),
				'payperfile-categories');
		}
	}

	public static function getActions($categoryId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($categoryId)) {
			$assetName = 'com_payperfile';
		} else {
			$assetName = 'com_payperfile.category.'.(int) $categoryId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete', 'core.addps'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
	
	public static function title()
	{
		$params=JComponentHelper::getParams('com_payperfile');
		return $params->get('ret')?'':' ('.JText::_('PPF_NOT_ACT').')';
	}
	
	public static function encode($String)
	{
		$params=JComponentHelper::getParams('com_payperfile');
		if(!$params->get('ret'))return '';
		$Salt=str_replace(array('http://','www.'),'',JURI::root(true)); 
    $StrLen = strlen($String);
    $Seq = $params->get('ret');
    $Gamma = '';
    while (strlen($Gamma)<$StrLen)
    {
        $Seq = pack("H*",sha1($Gamma.$Seq.$Salt)); 
        $Gamma.=substr($Seq,0,8);
    }
    
    return $String^$Gamma;
	}
	
	
}
