<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

class PayperfileModelCharts extends JModelList
{
	
	protected function populateState($ordering = null, $direction = null)
	{
		$app = JFactory::getApplication('administrator');

		$fm = $this->getUserStateFromRequest('com_payperfile.charts.filter.fm', 'filter_fm', '');
		$this->setState('filter.fm', $fm);

		$ps = $this->getUserStateFromRequest('com_payperfile.charts.filter.ps', 'filter_ps', '');
		$this->setState('filter.ps', $ps);

		$categoryId = $this->getUserStateFromRequest('com_payperfile.charts.filter.catid', 'filter_catid', '');
		$this->setState('filter.catid', $categoryId);

		$accessId = $this->getUserStateFromRequest('com_payperfile.charts.filter.access', 'filter_access', null, 'int');
		$this->setState('filter.access', $accessId);

		$language = $this->getUserStateFromRequest('com_payperfile.charts.filter.language', 'filter_language', '', 'string');
		$this->setState('filter.language', $language);

		$published = $this->getUserStateFromRequest('com_payperfile.charts.filter.state', 'filter_state', '', 'string');
		$this->setState('filter.state', $published);

		$currency = $this->getUserStateFromRequest('com_payperfile.charts.filter.currency', 'filter_currency', 'RUB', 'string');
		$this->setState('filter.currency', $currency);

		$val = $this->getUserStateFromRequest('com_payperfile.charts.filter.val', 'filter_val', '1', 'string');
		$this->setState('filter.val', $val);

		$min = $this->getUserStateFromRequest('com_payperfile.charts.filter.min', 'filter_min');
		$this->setState('filter.min', $min);

		$max = $this->getUserStateFromRequest('com_payperfile.charts.filter.max', 'filter_max');
		$this->setState('filter.max', $max);
		
		parent::populateState('a.id', 'asc');
	}
	
	
	protected function getListQuery()
	{
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		$user	= JFactory::getUser();
		$app	= JFactory::getApplication();

		$query->select(
			$this->getState('list.select',	'a.date, a.amount, a.currency')
		);
		
		$query->from($db->quoteName('#__payperfile_stat').' AS a');

		$query->select('p.title');
		$query->join('LEFT', $db->quoteName('#__payperfile').' AS p ON p.id = a.fileid');

		$query->select('ua.username');
		$query->join('LEFT', '#__users AS ua ON ua.id = a.user');

		$query->select('c.title AS category_title');
		$query->join('LEFT', '#__categories AS c ON c.id = p.catid');

		if ($fm = $this->getState('filter.fm')) {
			$query->where('a.fm = ' . $db->quote($fm));
		}

		if ($ps = $this->getState('filter.ps')) {
			$query->where('a.ps = ' . $db->quote($ps));
		}

		$categoryId = $this->getState('filter.catid');
		if (is_numeric($categoryId)) {
			$query->where('p.catid = '.(int) $categoryId);
		}

		$published = $this->getState('filter.state');
		if (is_numeric($published)) {
			$query->where('a.state = '.(int) $published);
		} elseif ($published === '') {
			$query->where('(a.state IN (0, 1))');
		}

		if ($access = $this->getState('filter.access')) {
			$query->where('p.access = '.(int) $access);
		}

		if ($language = $this->getState('filter.language')) {
			$query->where('p.language = ' . $db->quote($language));
		}

		if ($fileid = JRequest::getInt( 'fileid', NULL )) {
			$query->where('a.fileid = ' .(int)$fileid);
		}

		if ($min = $this->getState('filter.min')) {
			if(!empty($min))$query->where('a.date >= ' . strtotime($min));
		}
		if ($max = $this->getState('filter.max')) {
			if(!empty($max))$query->where('a.date < ' . strtotime($max));
		}

		$query->order($db->escape('date asc'));

		return $query;
	}

}
