<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

class PayperfileModelPayperfile extends JModelAdmin
{
	protected function canDelete($record)
	{
		if (!empty($record->id)) {
			if ($record->state != -2) {
				return ;
			}
			$user = JFactory::getUser();

			if ($record->catid) {
				return $user->authorise('core.delete', 'com_payperfile.category.'.(int) $record->catid);
			}
			else {
				return parent::canDelete($record);
			}
		}
	}
	
	protected function canEditState($record)
	{
		$user = JFactory::getUser();

		if (!empty($record->catid)) {
			return $user->authorise('core.edit.state', 'com_payperfile.category.'.(int) $record->catid);
		}
		else {
			return parent::canEditState($record);
		}
	}
	
	public function getTable($type = 'Payperfile', $prefix = 'PayperfileTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	public function getForm($data = array(), $loadData = true)
	{
		$app	= JFactory::getApplication();

		$form = $this->loadForm('com_payperfile.payperfile', 'payperfile', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}

		if ($this->getState('payperfile.id')) {
			$form->setFieldAttribute('catid', 'action', 'core.edit');
		} else {
			$form->setFieldAttribute('catid', 'action', 'core.create');
		}

		if (!$this->canEditState((object) $data)) {
			$form->setFieldAttribute('ordering', 'disabled', 'true');
			$form->setFieldAttribute('state', 'disabled', 'true');

			$form->setFieldAttribute('ordering', 'filter', 'unset');
			$form->setFieldAttribute('state', 'filter', 'unset');
		}

		return $form;
	}
	
	protected function loadFormData()
	{
		$data = JFactory::getApplication()->getUserState('com_payperfile.edit.payperfile.data', array());

		if (empty($data)) {
			$data = $this->getItem();

			if ($this->getState('payperfile.id') == 0) {
				$app = JFactory::getApplication();
				$data->set('catid', JRequest::getInt('catid', $app->getUserState('com_payperfile.payperfiles.filter.category_id')));
			}
		}

		return $data;
	}

	protected function prepareTable($table)
	{
		$date = JFactory::getDate();
		$user = JFactory::getUser();

		$post	= JRequest::get('post');
		$registry = new JRegistry();
		$registry->loadArray($post['params']);
		$table->params =(string)$registry;
		$table->title		= htmlspecialchars_decode($table->title, ENT_QUOTES);

		if (empty($table->fm)) {
			$table->fm = $post['fm'];
		}

		if (empty($table->id)) {
			if (empty($table->ordering)) {
				$db = JFactory::getDbo();
				$db->setQuery('SELECT MAX(ordering) FROM #__payperfile');
				$max = $db->loadResult();

				$table->ordering = $max+1;
			}
		}
		else {
			// Set the values
		}
	}

	protected function getReorderConditions($table)
	{
		$condition = array();
		$condition[] = 'catid = '.(int) $table->catid;
		return $condition;
	}

}
?>