<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

jimport('joomla.application.component.modeladmin');

class payperfileModelPaysystem extends JModelAdmin
{
	
	public function getTable($type = 'Paysystem', $prefix = 'PayperfileTable', $config = array())
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	public function getForm($data = array(), $loadData = true)
	{
		$form = $this->loadForm('com_payperfile.paysystem', 'paysystem', array('control' => 'jform', 'load_data' => $loadData));
		
		if (empty($form)) 	return false;

		return $form;
	}

	protected function loadFormData()
	{
		$data = JFactory::getApplication()->getUserState('com_payperfile.edit.paysystem.data', array());

		if (empty($data)) $data = $this->getItem();

		return $data;
	}

	protected function prepareTable($table)
	{
		$date = JFactory::getDate();
		$user = JFactory::getUser();

		$table->title		= htmlspecialchars_decode($table->title, ENT_QUOTES);

		$post	= JRequest::get('post');
	
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';
		foreach($post['params'] as $k=>$v){
			if(strpos($k,'secret_key')!==false)$post['params'][$k]=base64_encode(PayperfileHelper::encode($v));
		}
		
		$registry = new JRegistry();
		$registry->loadArray($post['params']);
		$table->params =(string)$registry;
		
		if (empty($table->ps)) $table->ps = $post['ps'];

		if (empty($table->id)) {
			if (empty($table->ordering)) {
				$db = JFactory::getDbo();
				$db->setQuery('SELECT MAX(ordering) FROM #__payperfile_ps');
				$max = $db->loadResult();

				$table->ordering = $max+1;
			}
		}
		else {
			// Set the values
		}
	}

}
