<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

class PayperfileTablePayperfile extends JTable
{

	function __construct(& $db) {
		parent::__construct('#__payperfile', 'id', $db);
	}

	function bind($array, $ignore = '')
	{
		if (isset($array['params']) && is_array($array['params'])) {
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = (string)$registry;
		}

		if (isset($array['pslist']) && is_array($array['pslist'])) {
			$registry = new JRegistry();
			$registry->loadArray($array['pslist']);
			$array['pslist'] = (string)$registry;
		}

		return parent::bind($array, $ignore);
	}
	
	public function delete($pk = null)
	{
		$params = JComponentHelper::getParams( 'com_payperfile' );
		$path = JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.'data'.DS.$this->folder;
		if($params->get( 'delete_file' ))JFile::delete($path.DS.$this->filename);
		$files = JFolder::files($path);
		if (empty($files)&&$this->folder&&$params->get( 'delete_folder' )) {
			JFolder::delete($path);
		}
		
		return parent::delete($pk);
	}
	
	public function store($updateNulls = false)
	{
		$date	= JFactory::getDate();
		if ($this->id) {
//			// Existing item
		} else {
			
			$this->date = $date->toSql();
		}
		
		
		return parent::store($updateNulls);
	}

	public function check()
	{
		if (trim($this->title) == '') {
			$this->setError(JText::_('COM_PPF_ERR_TABLES_TITLE'));
			return false;
		}

		if (trim($this->folder)) {
			$this->folder=JFolder::makeSafe($this->folder);
		}
		
		if (!$this->loadFile()) {
			return false;
		}
		
		$post=$_POST['jform'];

		if (isset($post['folder'])&&!trim($this->folder)) {
			$this->setError(JText::_('COM_PPF_ERR_TABLES_FOLDER'));
			return false;
		}

		if (isset($post['filename'])&&!trim($this->filename)) {
			$this->setError(JText::_('COM_PPF_ERR_TABLES_FILENAME'));
			return false;
		}

		return true;
	}

	public function publish($pks = null, $state = 1, $userId = 0)
	{
		$k = $this->_tbl_key;

		JArrayHelper::toInteger($pks);
		$userId = (int) $userId;
		$state  = (int) $state;

		if (empty($pks))
		{
			if ($this->$k) {
				$pks = array($this->$k);
			}

			else {
				$this->setError(JText::_('JLIB_DATABASE_ERROR_NO_ROWS_SELECTED'));
				return false;
			}
		}

		$where = $k.'='.implode(' OR '.$k.'=', $pks);

		if (!property_exists($this, 'checked_out') || !property_exists($this, 'checked_out_time')) {
			$checkin = '';
		}
		else {
			$checkin = ' AND (checked_out = 0 OR checked_out = '.(int) $userId.')';
		}

		$this->_db->setQuery(
			'UPDATE '.$this->_db->quoteName($this->_tbl) .
			' SET '.$this->_db->quoteName('state').' = '.(int) $state .
			' WHERE ('.$where.')' .
			$checkin
		);
		$this->_db->query();

		if ($this->_db->getErrorNum()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if ($checkin && (count($pks) == $this->_db->getAffectedRows()))
		{
			foreach($pks as $pk)
			{
				$this->checkin($pk);
			}
		}

		if (in_array($this->$k, $pks)) {
			$this->state = $state;
		}

		$this->setError('');
		return true;
	}

	function loadFile() {
		$filename = JRequest::getVar('uploadfile', array(), 'files', 'array');
		$params = JComponentHelper::getParams ( 'com_payperfile' );
		$arr = explode(",", $params->get ( 'type_file' ));
		$path=JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.'data';
		
		if(isset($filename['name'])&&$filename['name']) {
			
			if($this->filename) {
				$filenameSafe =  $this->filename;
			} else {
				$filenameSafe =  JFile::makeSafe($filename['name']);
			}
			
			if (in_array(JFile::getExt($filenameSafe), $arr)) {
				$this->setError(JText::_('PPF_TBL_FBD'));
				return false;
			}
			
			$filepath = $path.DS.$this->folder.DS.$filenameSafe;
			
			if(file_exists($filepath)&&!$_POST['upd']) {
				$this->setError(JText::_('PPF_TBL_OLR').' '.$filenameSafe);
				return false;
			}
			elseif($_POST['oldfilename']&&file_exists($path.DS.$_POST['oldfolder'].DS.$_POST['oldfilename'])&&$_POST['upd']){
				JFile::delete($path.DS.$_POST['oldfolder'].DS.$_POST['oldfilename']);
			}
			
			JFile::upload($filename['tmp_name'], $filepath, false, true);
			
			if(!file_exists($filepath)) {
				$this->setError(JText::_('PPF_TBL_FERR'));
				return false;
			}
			
			if(!chmod($filepath, 0600)) {
				$this->setError(JText::_('Cannot change the mode of file'.' '.$filenameSafe));
				return false;
			}
			
			$this->filename = $filenameSafe;
			
		}
		elseif($_POST['oldfolder'] && $_POST['oldfilename']) {
			
			if(!$this->filename) {
				$this->setError(JText::_('COM_PPF_ERR_TABLES_FILENAME'));
				return false;
			}

			if(!$this->folder) {
				$this->setError(JText::_('COM_PPF_ERR_TABLES_FOLDER'));
				return false;
			}

			if($_POST['oldfilename']!=$this->filename||$this->folder!=$_POST['oldfolder']) {
				$filepath = $path.DS.$this->folder.DS.$this->filename;
				
				if(file_exists($filepath)&&!$_POST['upd']) {
					$this->setError(JText::_('PPF_TBL_OLR'));
					return false;
				}
				
				if (in_array(JFile::getExt($this->filename), $arr)) {
					$this->setError(JText::_('PPF_TBL_FBD'));
					return false;
				}
				
				$oldfilepath = $path.DS.$_POST['oldfolder'].DS.$_POST['oldfilename'];
				
				if(!JFolder::exists( $path.DS.$this->folder ))JFolder::create($path.DS.$this->folder, $mode = 0755 ); 
				JFile::move($oldfilepath, $filepath);
				
				if(!file_exists($filepath)){
					$this->setError(JText::_('PPF_TBL_FERR2'));
					return false;
				}
				
				if($params->get( 'delete_folder' )){
					$files = JFolder::files($path.DS.$_POST['oldfolder']);
					if (empty($files)) {
						JFolder::delete($path.DS.$_POST['oldfolder']);
					}
				}
				
			}
			
		}
		
		return true;
	}
	
}
