<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

class PayperfileViewCharts extends JViewLegacy
{
	protected $items;
	protected $state;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->state->set('list.limit', 0);
		
		
		$min = JFactory::getApplication()->getUserStateFromRequest('com_payperfile.charts.filter.min', 'filter_min',date('Y-m-d',time()-365*24*60*60));
		$this->state->set('filter.min', $min);

		$max = JFactory::getApplication()->getUserStateFromRequest('com_payperfile.charts.filter.max', 'filter_max',date('Y-m-d',time()));
		$this->state->set('filter.max', $max);
		
		$val = JFactory::getApplication()->getUserStateFromRequest('com_payperfile.charts.filter.val', 'filter_val','ym');
		$this->state->set('filter.val', $val);
		
		$this->items		= $this->get('Items');

		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		PayperfileHelper::addSubmenu('statistics');
		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		$this->gfileid		= JRequest::getInt( 'fileid', NULL );
		
		parent::display($tpl);
	}
	
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';

		$db		= JFactory::getDBO();

		$arrc=JHtml::_('category.options', 'com_payperfile');
		$arrc[]=array('value'=>0,'text'=>'uncategorised');

		JToolBarHelper::title('PPF-2 ('.JText::_('PPF_V2_GS').')', '');
		
		JToolBarHelper::help('help1', true);
		
		JHtmlSidebar::setAction('index.php?option=com_payperfile&view=charts');

		$folders  = JFolder::folders(JPATH_COMPONENT.DS.'fm');
		foreach ($folders as $folder) {
			$xml = simplexml_load_file(JPATH_COMPONENT.DS.'fm'.DS.$folder.DS.$folder.'.xml');
			$arrfm[] = array ( "value"=>$folder, "text"=>$xml->name);
		}
		
		JHtmlSidebar::addFilter(
			JText::_('PPF_SFM'),
			'filter_fm',
			JHtml::_('select.options', $arrfm, 'value', 'text', $this->state->get('filter.fm'))
		);

		$db->setQuery('SELECT title as text, id FROM #__payperfile_ps WHERE state=1');
		$pslist = $db->loadObjectList();
		
		JHtmlSidebar::addFilter(
			JText::_('PPF_SPS'),
			'filter_ps',
			JHtml::_('select.options', $pslist, 'text', 'text', $this->state->get('filter.ps'), true)
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_PUBLISHED'),
			'filter_state',
			JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.state'), true)
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_CATEGORY'),
			'filter_catid',
			JHtml::_('select.options', $arrc, 'value', 'text', $this->state->get('filter.catid'))
		);
		
		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_ACCESS'),
			'filter_access',
			JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $this->state->get('filter.access'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_LANGUAGE'),
			'filter_language',
			JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language'))
		);
		
	}
	
}
