<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

class PayperfileViewPayperfile extends JViewLegacy
{
	protected $state;
	protected $item;
	protected $form;

	function display($tpl = null)
	{
		if (JRequest::getCmd( 'layout')=='addfm') 
		{
			JToolBarHelper::title(JText::_('COM_PAYPERFILE_NEW'), '');
			parent::display($tpl);
		} 
		else {
			$this->state	= $this->get('State');
			$this->item		= $this->get('Item');
			$this->form		= $this->get('Form');
			$db = JFactory::getDbo();
			
			if (count($errors = $this->get('Errors'))) {
				JError::raiseError(500, implode("\n", $errors));
				return false;
			}
			
			if(!$this->item->fm)$this->item->fm= 	JRequest::getCmd('fm');
			if(!$this->item->fm){
				$app	= JFactory::getApplication();
				$app->redirect(JRoute::_('index.php?option=com_payperfile&view=payperfile&layout=addfm', false));
			}
	
			$file 	= JPATH_COMPONENT.DS.'fm'.DS.$this->item->fm.DS.$this->item->fm.'.xml';
			if(file_exists($file)){
				$xml = simplexml_load_file($file);
				$this->item->psurl = $xml->url;
				$this->item->name = $xml->name;
				$this->item->resurl = $xml->resurl;
				$this->item->sucurl = $xml->sucurl;
				$this->item->failurl = $xml->failurl;
				$this->item->showfolder = $xml->showfolder;
				$this->item->showfile = $xml->showfile;
				$this->item->showprice = $xml->showprice;
				$this->item->showmail = $xml->showmail;
			}
			
			$db->setQuery('SELECT id as value, title as text FROM #__payperfile_ps WHERE state =1');
			$pslist = $db->loadObjectList();
			$appliedPslist=json_decode($this->item->pslist, TRUE);
			
			$lists['pslist'] = JHTML::_('select.genericlist', $pslist, 'jform[pslist][]', 'multiple="multiple" size="15"', 'value', 'text', $appliedPslist);
			
			$this->assignRef('lists', $lists);
	
			$this->addToolbar();
			parent::display($tpl);
		}
	}

	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', true);

		$user		= JFactory::getUser();
		$userId		= $user->get('id');
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));
		$canDo		= PayperfileHelper::getActions($this->item->catid, 0);

		JToolBarHelper::title(JText::_('PPF_TITLE'), '');

		if (!$checkedOut && ($canDo->get('core.edit')||(count($user->getAuthorisedCategories('com_payperfile', 'core.create')))))
		{
			JToolBarHelper::apply('payperfile.apply');
			JToolBarHelper::save('payperfile.save');
		}
		if (!$checkedOut && (count($user->getAuthorisedCategories('com_payperfile', 'core.create')))){
			JToolBarHelper::save2new('payperfile.save2new');
		}
		// If an existing item, can save to a copy.
		if (!$isNew && (count($user->getAuthorisedCategories('com_payperfile', 'core.create')) > 0)) {
			JToolBarHelper::save2copy('payperfile.save2copy');
		}
		if (empty($this->item->id)) {
			JToolBarHelper::cancel('payperfile.cancel');
		}
		else {
			JToolBarHelper::cancel('payperfile.cancel', 'JTOOLBAR_CLOSE');
		}

		JToolBarHelper::divider();
		JToolBarHelper::help('help1', true);
	}

}
