<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/

defined('_JEXEC') or die;

class PayperfileViewPayperfiles extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		
		PayperfileHelper::addSubmenu('payperfiles');

		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		
		parent::display($tpl);
	}

	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';

		$state	= $this->get('State');
		$canDo	= PayperfileHelper::getActions($state->get('filter.category_id'));
		$user	= JFactory::getUser();
		$bar = JToolBar::getInstance('toolbar');
		
		$arrc=JHtml::_('category.options', 'com_payperfile');
		$arrc[]=array('value'=>0,'text'=>'uncategorised');

		JToolBarHelper::title(JText::_('PPF_TITLE').PayperfileHelper::title(), '');
		
		if (count($arrc)>1){
			if (count($user->getAuthorisedCategories('com_payperfile', 'core.create')) > 0) {
				JToolBarHelper::addNew('payperfile.addfm');
			}
		}else{
			JToolBarHelper::addNew('payperfile.addfm');
		}
		if ($canDo->get('core.edit')) {
			JToolBarHelper::editList('payperfile.edit');
		}
		if ($canDo->get('core.edit.state')) {

			JToolBarHelper::divider();
			JToolBarHelper::publish('payperfiles.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('payperfiles.unpublish', 'JTOOLBAR_UNPUBLISH', true);


			JToolBarHelper::divider();
			JToolBarHelper::archiveList('payperfiles.archive');
			JToolBarHelper::checkin('payperfiles.checkin');
		}
		if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			JToolBarHelper::deleteList('', 'payperfiles.delete', 'JTOOLBAR_EMPTY_TRASH');
			JToolBarHelper::divider();
		} elseif ($canDo->get('core.edit.state')) {
			JToolBarHelper::trash('payperfiles.trash');
			JToolBarHelper::divider();
		}
		
		// Add a batch button
		if ($canDo->get('core.edit'))
		{
			JHtml::_('bootstrap.modal', 'collapseModal');
			$title = JText::_('JTOOLBAR_BATCH');
			$dhtml = "<button data-toggle=\"modal\" data-target=\"#collapseModal\" class=\"btn btn-small\">
						<i class=\"icon-checkbox-partial\" title=\"$title\"></i>
						$title</button>";
			$bar->appendButton('Custom', $dhtml, 'batch');
		}
		
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_payperfile');
			JToolBarHelper::divider();
		}

		JToolBarHelper::help('help1', true);
		
		
		JHtmlSidebar::setAction('index.php?option=com_payperfile&view=payperfiles');

		$folders  = JFolder::folders(JPATH_COMPONENT.DS.'fm');
		foreach ($folders as $folder) {
			$xml = simplexml_load_file(JPATH_COMPONENT.DS.'fm'.DS.$folder.DS.$folder.'.xml');
			$arrfm[] = array ( "value"=>$folder, "text"=>JText::_($xml->name));
		}
		
		JHtmlSidebar::addFilter(
			JText::_('PPF_SFM'),
			'filter_fm',
			JHtml::_('select.options', $arrfm, 'value', 'text', $this->state->get('filter.fm'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_PUBLISHED'),
			'filter_state',
			JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.state'), true)
		);
		
		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_CATEGORY'),
			'filter_catid',
			JHtml::_('select.options', $arrc, 'value', 'text', $this->state->get('filter.catid'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_ACCESS'),
			'filter_access',
			JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $this->state->get('filter.access'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_LANGUAGE'),
			'filter_language',
			JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language'))
		);
		
	}
	
	protected function getSortFields()
	{
		return array(
			'a.ordering' => JText::_('JGRID_HEADING_ORDERING'),
			'a.state' => JText::_('JSTATUS'),
			'a.title' => JText::_('JGLOBAL_TITLE'),
			'a.access' => JText::_('JGRID_HEADING_ACCESS'),
			'a.hits' => JText::_('JGLOBAL_HITS'),
			'a.language' => JText::_('JGRID_HEADING_LANGUAGE'),
			'a.id' => JText::_('JGRID_HEADING_ID')
		);
	}
	
}
