<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

class PayperfileViewPaysystem extends JViewLegacy
{
	protected $state;
	protected $item;
	protected $form;

	function display($tpl = null)
	{
		if (JRequest::getCmd( 'layout')=='addps') 
		{
			JToolBarHelper::title(JText::_('COM_PAYPERFILE_NEW'), '');
			parent::display($tpl);
		} 
		else {
			
			$this->state	= $this->get('State');
			$this->item		= $this->get('Item');
			$this->form		= $this->get('Form');
			
			if (count($errors = $this->get('Errors'))) {
				JError::raiseError(500, implode("\n", $errors));
				return false;
			}
			
			if(!$this->item->ps)$this->item->ps= 	JRequest::getCmd('ps');
			if(!$this->item->ps){
				$app	= JFactory::getApplication();
				$app->redirect(JRoute::_('index.php?option=com_payperfile&view=paysystem&layout=addps', false));
			}
	
			$file 	= JPATH_COMPONENT.DS.'ps'.DS.$this->item->ps.DS.$this->item->ps.'.xml';
			if(file_exists($file)){
				$xml = simplexml_load_file($file);
				$this->item->psurl = $xml->url;
				$this->item->resurl = $xml->resurl;
				$this->item->sucurl = $xml->sucurl;
				$this->item->failurl = $xml->failurl;
				$this->item->showfolder = $xml->showfolder;
				$this->item->showfile = $xml->showfile;
				$this->item->showprice = $xml->showprice;
				$this->item->desc = $xml->desc;
			}
			
			PayperfileHelper::addSubmenu('paysystems');
			$this->addToolbar();
			$this->sidebar = JHtmlSidebar::render();
			parent::display($tpl);
		}
	}

	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', true);
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';
		
		$user		= JFactory::getUser();
		$userId		= $user->get('id');
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));
		$canDo		= PayperfileHelper::getActions();

		JToolBarHelper::title('PPF-2 ('.JText::_('PPF_PS').')', '');

		if (!$checkedOut && ($canDo->get('core.edit')||(count($user->getAuthorisedCategories('com_payperfile', 'core.create')))))
		{
			JToolBarHelper::apply('paysystem.apply');
			JToolBarHelper::save('paysystem.save');
		}
		if (!$checkedOut && (count($user->getAuthorisedCategories('com_payperfile', 'core.create')))){
			JToolBarHelper::save2new('paysystem.save2new');
		}
		// If an existing item, can save to a copy.
		if (!$isNew && (count($user->getAuthorisedCategories('com_payperfile', 'core.create')) > 0)) {
			JToolBarHelper::save2copy('paysystem.save2copy');
		}
		if (empty($this->item->id)) {
			JToolBarHelper::cancel('paysystem.cancel');
		}
		else {
			JToolBarHelper::cancel('paysystem.cancel', 'JTOOLBAR_CLOSE');
		}

		JHtmlSidebar::setAction('index.php?option=com_payperfile&view=paysystems');

		JToolBarHelper::divider();
		JToolBarHelper::help('help1', true);
	}

}

?>