<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;
class PayperfileViewPaysystems extends JViewLegacy
{
	
	protected $items;
	protected $pagination;
	protected $state;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		

		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		PayperfileHelper::addSubmenu('paysystems');
		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		
		parent::display($tpl);
	}

	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';

		$state	= $this->get('State');
		$canDo	= PayperfileHelper::getActions();

		JToolBarHelper::title('PPF-2 ('.JText::_('PPF_PS').')'.PayperfileHelper::title(), '');
		
		if ($canDo->get('core.addps')) {
			JToolBarHelper::addNew('paysystem.addps');
		}

		if ($canDo->get('core.edit')) {
			JToolBarHelper::editList('paysystem.edit');
		}
		if ($canDo->get('core.edit.state')) {

			JToolBarHelper::divider();
			JToolBarHelper::publish('paysystems.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('paysystems.unpublish', 'JTOOLBAR_UNPUBLISH', true);


			JToolBarHelper::divider();
			JToolBarHelper::archiveList('paysystems.archive');
			JToolBarHelper::checkin('paysystems.checkin');
		}
		if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			JToolBarHelper::deleteList('', 'paysystems.delete', 'JTOOLBAR_EMPTY_TRASH');
			JToolBarHelper::divider();
		} elseif ($canDo->get('core.edit.state')) {
			JToolBarHelper::trash('paysystems.trash');
			JToolBarHelper::divider();
		}
		
		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_payperfile');
			JToolBarHelper::divider();
		}

		JToolBarHelper::help('help1', true);
		
		
		JHtmlSidebar::setAction('index.php?option=com_payperfile&view=paysystems');


		$folders  = JFolder::folders(JPATH_COMPONENT.DS.'ps');
		foreach ($folders as $folder) {
			$xml = simplexml_load_file(JPATH_COMPONENT.DS.'ps'.DS.$folder.DS.$folder.'.xml');
			$pslist[] = array ( "value"=>$folder, "text"=>$xml->name);
			$pslist2[$folder] =$xml->name;
		}
		$this->pslist2=$pslist2;

		JHtmlSidebar::addFilter(
			JText::_('PPF_SPS'),
			'filter_ps',
			JHtml::_('select.options', $pslist, 'value', 'text', $state->get('filter.ps'), true)
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_PUBLISHED'),
			'filter_state',
			JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $state->get('filter.state'), true)
		);
		
		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_ACCESS'),
			'filter_access',
			JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $state->get('filter.access'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_LANGUAGE'),
			'filter_language',
			JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $state->get('filter.language'))
		);
		
	}
	
	protected function getSortFields()
	{
		return array(
			'a.ordering' => JText::_('JGRID_HEADING_ORDERING'),
			'a.state' => JText::_('JSTATUS'),
			'a.title' => JText::_('JGLOBAL_TITLE'),
			'a.access' => JText::_('JGRID_HEADING_ACCESS'),
			'a.language' => JText::_('JGRID_HEADING_LANGUAGE'),
			'a.id' => JText::_('JGRID_HEADING_ID')
		);
	}
	
}
