<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

class PayperfileViewStatistics extends JViewLegacy
{
	protected $items;
	protected $pagination;
	protected $state;

	public function display($tpl = null)
	{
		$this->state		= $this->get('State');
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->gfileid		= JRequest::getInt( 'fileid', NULL );

		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
		
		PayperfileHelper::addSubmenu('statistics');
		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		
		parent::display($tpl);
	}
	
	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/payperfile.php';

		$state	= $this->get('State');
		$canDo	= PayperfileHelper::getActions();
		$db		= JFactory::getDBO();

		$arrc=JHtml::_('category.options', 'com_payperfile');
		$arrc[]=array('value'=>0,'text'=>'uncategorised');

		JToolBarHelper::title('PPF-2 ('.JText::_('PPF_V7_STAT').')'.PayperfileHelper::title(), '');
		
		if ($canDo->get('core.edit.state')) {

			JToolBarHelper::divider();
			JToolBarHelper::publish('statistics.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('statistics.unpublish', 'JTOOLBAR_UNPUBLISH', true);


			JToolBarHelper::divider();
			JToolBarHelper::archiveList('statistics.archive');
		}
		if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			JToolBarHelper::deleteList('', 'statistics.delete', 'JTOOLBAR_EMPTY_TRASH');
			JToolBarHelper::divider();
		} elseif ($canDo->get('core.edit.state')) {
			JToolBarHelper::trash('statistics.trash');
			JToolBarHelper::divider();
		}

		JToolBarHelper::help('help1', true);
		
		JHtmlSidebar::setAction('index.php?option=com_payperfile&view=statistics');

		$folders  = JFolder::folders(JPATH_COMPONENT.DS.'fm');
		foreach ($folders as $folder) {
			$xml = simplexml_load_file(JPATH_COMPONENT.DS.'fm'.DS.$folder.DS.$folder.'.xml');
			$arrfm[] = array ( "value"=>$folder, "text"=>JText::_($xml->name));
		}
		
		JHtmlSidebar::addFilter(
			JText::_('PPF_SFM'),
			'filter_fm',
			JHtml::_('select.options', $arrfm, 'value', 'text', $this->state->get('filter.fm'))
		);

		$db->setQuery('SELECT title as text, id FROM #__payperfile_ps WHERE state=1');
		$pslist = $db->loadObjectList();
		
		JHtmlSidebar::addFilter(
			JText::_('PPF_SPS'),
			'filter_ps',
			JHtml::_('select.options', $pslist, 'text', 'text', $state->get('filter.ps'), true)
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_PUBLISHED'),
			'filter_state',
			JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.state'), true)
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_CATEGORY'),
			'filter_catid',
			JHtml::_('select.options', $arrc, 'value', 'text', $this->state->get('filter.catid'))
		);
		
		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_ACCESS'),
			'filter_access',
			JHtml::_('select.options', JHtml::_('access.assetgroups'), 'value', 'text', $state->get('filter.access'))
		);

		JHtmlSidebar::addFilter(
			JText::_('JOPTION_SELECT_LANGUAGE'),
			'filter_language',
			JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $state->get('filter.language'))
		);
		
	}
	
	protected function getSortFields()
	{
		return array(
			'a.ps' => JText::_('PPF_PS'),
			'a.fm' => JText::_('PPF_V4_FANC'),
			'a.date' => JText::_('JDATE'),
			'a.ip' => JText::_('PPF_IPADR'),
			'a.amount' => JText::_('PPF_AMMAUNT'),
			'a.currency' => JText::_('CURRENCY'),
			'a.user' => JText::_('PPF_USER'),
			'a.id' => JText::_('JGRID_HEADING_ID')
		);
	}
}
